#version 120
// (C) 2009 Dmytry Lavrov. All rights reserved.
varying vec2 texture_coordinate;
uniform sampler2D my_color_texture;
uniform float power;
uniform float desaturate;

void main()
{
	vec3 col=texture2D(my_color_texture, texture_coordinate).rgb;
	col=clamp(col, 0.0, 100.0);
	vec3 col_p=vec3(pow(col.r, power), pow(col.g, power), pow(col.b, power));
	float avg=(col_p.r+col_p.g+col_p.b)*(1.0/3.0);
	float a=avg*desaturate;
	col_p=col_p*(1.0-desaturate)+vec3(a,a,a);

	//vec3 col2=texture2D(my_color_texture, texture_coordinate+vec2(-0.003,0.003)).rgb;
	//avg=(col2.r+col2.g+col2.b)*(1.0/3.0);
	//float alpha=clamp(avg*200.0-80.0, 0.0, 0.8);
	//float alpha=1-exp(-avg*20);
	gl_FragColor = vec4(clamp(col_p*gl_Color.rgb,0.0,1.0), 0.0);
}
